%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%if 0%{?fedora} > 23
%global with_python3 1
%endif

%global pypi_name taskflow

%global common_desc \
A library to do [jobs, tasks, flows] in a HA manner using \
different backends to be used with OpenStack projects.

Name:           python-%{pypi_name}
Version:        3.2.0
Release:        1%{?dist}
Summary:        Taskflow structured state management library

License:        ASL 2.0
URL:            https://launchpad.net/taskflow
Source0:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{upstream_version}.tar.gz
BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-pbr
BuildRequires:  git
BuildRequires:  python-babel
BuildRequires:  openstack-macros

Requires:       python-cachetools >= 2.0.0
Requires:       python-futures
Requires:       python-jsonschema
Requires:       python-six
Requires:       python-stevedore
Requires:       python-oslo-serialization >= 2.18.0
Requires:       python-oslo-utils >= 3.33.0
Requires:       python-debtcollector
Requires:       python-automaton >= 1.9.0
Requires:       python-futurist >= 1.2.0
Requires:       python-fasteners >= 0.7
Requires:       python-tenacity >= 4.4.0
%if 0%{?fedora} > 0
Requires:       python-enum34
Requires:       python-contextlib2 >= 0.4.0
Requires:       python-networkx >= 1.10
Requires:       python-networkx-core
%else
Requires:       python-enum34
Requires:       python-contextlib2 >= 0.4.0
Requires:       python-networkx >= 1.10
Requires:       python-networkx-core
%endif

%description
%{common_desc}

%if 0%{?with_python3}
%package -n python3-%{pypi_name}
Summary:        Taskflow structured state management library
BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-babel

Requires:       python3-six
Requires:       python3-stevedore
Requires:       python3-networkx-core
Requires:       python3-oslo-serialization >= 2.18.0
Requires:       python3-oslo-utils >= 3.33.0
Requires:       python3-jsonschema
Requires:       python3-enum34
Requires:       python3-debtcollector
Requires:       python3-automaton >= 1.9.0
Requires:       python3-networkx >= 1.10
Requires:       python3-futurist >= 1.2.0
Requires:       python3-fasteners >= 0.7
Requires:       python3-tenacity >= 4.4.0
Requires:       python3-contextlib2 >= 0.4.0
Requires:       python3-cachetools >= 2.0.0

%{?python_provide:%python_provide python3-%{pypi_name}}


%description -n python3-%{pypi_name}
%{common_desc}
%endif


%package doc
Summary:          Documentation for Taskflow
BuildRequires:  python-alembic
BuildRequires:  python-cachetools
BuildRequires:  python-jsonschema
BuildRequires:  python-openstackdocstheme
BuildRequires:  python-sphinx
BuildRequires:  graphviz
BuildRequires:  python-oslo-utils
BuildRequires:  python-stevedore
BuildRequires:  python-oslo-serialization
BuildRequires:  python-futurist
BuildRequires:  python-fasteners
BuildRequires:  python-automaton
BuildRequires:  python-kombu
BuildRequires:  python-tenacity
%if 0%{?fedora} > 0
BuildRequires:  python-enum34
BuildRequires:  python-contextlib2
BuildRequires:  python-redis
BuildRequires:  python-kazoo
BuildRequires:  python-networkx
BuildRequires:  python-sqlalchemy-utils
%else
BuildRequires:  python-enum34
BuildRequires:  python-contextlib2
BuildRequires:  python-redis
BuildRequires:  python-kazoo
BuildRequires:  python-networkx
BuildRequires:  python-sqlalchemy-utils
%endif


%description doc
%{common_desc}

This package contains the associated documentation.

%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# TODO(apevec) remove once python-networking subpackaging is fixed
sed -i /networkx.drawing/d taskflow/types/graph.py

# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup


%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif
# generate html docs
%{__python2} setup.py build_sphinx -b html
# remove the sphinx-build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}


%install
%py2_install
%if 0%{?with_python3}
%py3_install
%endif


%files 
%doc README.rst
%license LICENSE
%{python2_sitelib}/%{pypi_name}
%{python2_sitelib}/%{pypi_name}-*.egg-info

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%doc README.rst
%license LICENSE
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-*.egg-info
%endif

%files doc
%doc doc/build/html
%license LICENSE

%changelog
* Fri Aug 10 2018 RDO <dev@lists.rdoproject.org> 3.2.0-1
- Update to 3.2.0

